#include "codavt.h"
#include <iostream>

using namespace std;

int main(){

static const int M = 3;
static const int N = 10;
// semplificazione: N pari!
Coda<int> code[M];
// assegnazione N/2 utenti
int middle=N/2;
for (int i=1; i<=middle; i++)
{
   int in = rand() % M;
   code[in].inCoda(i);
   cout << "inserito utente: " << i << " in coda: "<< in << endl;
}
cout << "SITUAZIONE CODE DOPO INSERIMENTI"<< endl;
for (int k=0; k<M; k++)
{
   code[k].stampaCoda();
   cout << endl;
}

for (int i=middle+1; i<=N; i++)
{
   // sistemiamo gli altri utenti e nel contempo serviamo i primi N/2 accodati
   
   
   int in = rand() % M;
   cout << "Accodato Utente: " << i << " in coda: "<< in << endl;
   code[in].inCoda(i);
   int out = rand() % M;
   
   while (code[out].codaVuota())
      out= rand() % M;
   cout << "Servito Utente: " << code[out].leggiCoda() << endl;
   code[out].fuoriCoda();
   for (int k=0; k<M; k++)
   {
      code[k].stampaCoda();
      cout << endl;
   }   
}
// ora serviamo gli ultimi fino ad esaurimento
  cout << "ORA SERVIAMO AD ESAURIMENTO"  << endl;
  bool continua = false;
  for (int i=0; i<M; i++)
     continua = (continua || !code[i].codaVuota());
  while (continua)
  {
     int out= rand() % M; // cerca una coda non vuota;
     while (code[out].codaVuota())
        out= rand() % M;
     cout << "Servito Utente: " << code[out].leggiCoda() << endl;
     code[out].fuoriCoda();
     for (int k=0; k<M; k++)
     {
        code[k].stampaCoda();
        cout << endl;
     }
     continua = false;
     for (int i=0; i<M; i++)
        continua = (continua || !code[i].codaVuota());   
  }
  system("PAUSE");
  return EXIT_SUCCESS;
}
